	/* G N O K K I
	   A Linux/Unix toolset and driver for the Nokia 3110/3810/8110 mobiles.
	   Copyright (C) Hugh Blemings, 1999  Released under the terms of 
       the GNU GPL, see file COPYING for more details.
	
	   This file:  fbus.h

	   Header file for the various functions, definitions etc. used
	   to implement the handset interface.  See fbus.c for more details. */


	/* Some general defines. */

#ifndef u8
	typedef	unsigned char		u8;
#endif	

#ifndef 	false
	#define		false (0)
#endif

#ifndef		true
	#define		true (!false)
#endif


	/* Defines, enums etc. specific to fbus code. */
#define		FBUS_MAX_RECEIVE_LENGTH 	(512)
#define		FBUS_MAX_TRANSMIT_LENGTH	(256)

enum	FBUS_RX_States {FBUS_RX_Initialise,
						FBUS_RX_Sync,
						FBUS_RX_GetLength,
						FBUS_RX_GetMessage};

	/* Global variables */
extern int						FBUS_LinkOK;

	/* Prototypes */
void	FBUS_Initialise(int fd);

void	FBUS_RX_StateMachine(char rx_byte);
void	FBUS_RX_DispatchMessage(void);
void	FBUS_RX_DisplayMessage(void);

void    FBUS_RX_Handle0x0b_IncomingCall(void);
void    FBUS_RX_Handle0x4b_Status(void);
void    FBUS_RX_Handle0x10_EndOfOutgoingCall(void);
void    FBUS_RX_Handle0x11_EndOfIncomingCall(void);
void    FBUS_RX_Handle0x12_EndOfOutgoingCall(void);
void    FBUS_RX_Handle0x0d_IncomingCallAnswered(void);
void    FBUS_RX_Handle0x0e_OutgoingCallAnswered(void);
void	FBUS_RX_Handle0x41_SMSMessageCentreData(void);
void    FBUS_RX_Handle0x46_MemoryLocationData(void);


void    FBUS_TX_UpdateSequenceNumber(void);
int     FBUS_TX_SendStandardAcknowledge(u8 message_type);

int		FBUS_TX_SendMessage(u8 message_length, u8 message_type, u8 sequence_byte, u8 *buffer);
void 	FBUS_TX_Send0x3fMessage(void); 
void 	FBUS_TX_Send0x4aMessage(void);
void    FBUS_TX_Send0x43_RequestMemoryLocation(u8 memory_area, u8 location);
void    FBUS_TX_Send0x15Message(u8 sequence_number);



